﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Problem_A
{
    class Program
    {
        static void Main(string[] args)
        {
            var getInputValue = Console.ReadLine();
            
            var charArray = getInputValue.ToCharArray();

            if (charArray.Length > 1000)
                throw new Exception("More than 1000 values, input error");

            var countsArray = GetCountsInput(charArray); 

            ParseToRightMoves(ref countsArray);

            foreach (var value in countsArray)
                Console.Write(value);

            Console.ReadKey();
        }

        private static List<int> GetCountsInput(char[] inputValue)
        {
            List<int> returnCounts = new List<int>();

            foreach (var value in inputValue)
            {                
                returnCounts.Add(int.Parse(value.ToString()));
            }

            return returnCounts;
        }

        private static void ParseToRightMoves(ref List<int> array)
        {
            Console.WriteLine("Start validate");

            Dictionary<int, int> checkableValues = new Dictionary<int, int>();

            for (var i = 0; i < array.Count; i++)
            {
                if (i == 0)
                    continue;

                var nowMove = array[i];

                var lastMove = array[i - 1];

                if (!IsValidateMove(nowMove, lastMove))
                {
                    Console.WriteLine(nowMove + " not validated");                    

                    array[i] = lastMove;
                    
                    break;
                }                
            }

            if (checkableValues.Count > 0)
            {
                Console.WriteLine("Set right values");

                foreach (var check in checkableValues)
                {
                    array[check.Key] = check.Value;
                }
            }

            Console.WriteLine("End validate");
        }

        private static bool IsValidateMove(int checkMove, int lastMove)
        {
            switch (checkMove)
            {
                case 1:
                    return lastMove != 3;
                case 2:
                    return lastMove != 4;
                case 3:
                    return lastMove != 1;
                case 4:
                    return lastMove != 2;
            }

            return false;
        }
    }
}
