﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Problem_A
{
    class Program
    {
        static void Main(string[] args)
        {
            var getInputValue = Console.ReadLine();
            
            var charArray = getInputValue.ToCharArray();

            if (charArray.Length > 1000)
                throw new Exception("More than 1000 values, input error");

            var countsArray = GetCountsInput(charArray); 

            ParseToRightMoves(ref countsArray);

            foreach (var value in countsArray)
                Console.Write(value);

            Console.ReadKey();
        }

        private static List<int> GetCountsInput(char[] inputValue)
        {
            List<int> returnCounts = new List<int>();

            foreach (var value in inputValue)
            {                
                returnCounts.Add(int.Parse(value.ToString()));
            }

            return returnCounts;
        }

        private static void ParseToRightMoves(ref List<int> array)
        {
            for (var i = 0; i < array.Count; i++)
            {
                if (i == 0)
                    continue;

                var nowMove = array[i];

                var lastMove = array[i - 1];
                var nextMove = 0;

                if (i == array.Count - 1)
                    nextMove = 0;
                else
                    nextMove = array[i + 1];

                if (!IsValidateMove(nowMove, lastMove))
                {
                    Console.WriteLine(nowMove);
                    array[i] = GetRightValue(lastMove, nextMove);
                }                
            }
        }

        private static int GetRightValue(int prevCount, int NextCount)
        {
            switch (prevCount)
            {
                case 1:
                    if (NextCount == 3)
                        return 1;
                    else
                        return 4;
                case 2:
                    if (NextCount == 4)
                        return 2;
                    else
                        return 3;
                case 3:
                    if (NextCount == 1)
                        return 3;
                    else
                        return 4;
                case 4:
                    if (NextCount == 2)
                        return 4;
                    else
                        return 1;                    
            }

            return 1;
        }

        private static bool IsValidateMove(int checkMove, int lastMove)
        {
            switch (checkMove)
            {
                case 1:
                    return lastMove != 3;
                case 2:
                    return lastMove != 4;
                case 3:
                    return lastMove != 1;
                case 4:
                    return lastMove != 2;
            }

            return false;
        }
    }
}
